3 # Copyright (c) 2005 Junio C Hamano.
6 USAGE
='[--interactive | -i] [-v] [--force-rebase | -f] [--no-ff] [--onto <newbase>] (<upstream>|--root) [<branch>] [--quiet | -q]'
7 LONG_USAGE
='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To restore the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
23 Example: git-rebase master~1 topic
25 A---B---C topic A'\''--B'\''--C'\'' topic
27 D---E---F---G master D---E---F---G master
33 set_reflog_action rebase
39 OK_TO_SKIP_PRE_REBASE
=
41 When you have resolved this problem run \"git rebase --continue\".
42 If you would prefer to skip this patch, instead run \"git rebase --skip\".
43 To restore the original branch and stop rebasing run \"git rebase --abort\".
48 dotest
="$GIT_DIR"/rebase-merge
51 diffstat
=$
(git config
--bool rebase.stat
)
55 allow_rerere_autoupdate
=
58 test -n "$prev_head" || die
"prev_head must be defined"
59 test -d "$dotest" || die
"$dotest directory does not exist"
61 unmerged
=$
(git ls-files
-u)
62 if test -n "$unmerged"
64 echo "You still have unmerged paths in your index"
65 echo "did you forget to use git add?"
69 cmt
=`cat "$dotest/current"`
70 if ! git diff-index
--quiet --ignore-submodules HEAD
--
72 if ! git commit
--no-verify -C "$cmt"
74 echo "Commit failed, please do not call \"git commit\""
75 echo "directly, but instead do one of the following: "
78 if test -z "$GIT_QUIET"
80 printf "Committed: %0${prec}d " $msgnum
82 echo "$cmt $(git rev-parse HEAD^0)" >> "$dotest/rewritten"
84 if test -z "$GIT_QUIET"
86 printf "Already applied: %0${prec}d " $msgnum
89 test -z "$GIT_QUIET" &&
90 GIT_PAGER
='' git log
--format=%s
-1 "$cmt"
92 prev_head
=`git rev-parse HEAD^0`
93 # save the resulting commit so we can read-tree on it later
94 echo "$prev_head" > "$dotest/prev_head"
96 # onto the next patch:
97 msgnum
=$
(($msgnum + 1))
98 echo "$msgnum" >"$dotest/msgnum"
102 cmt
="$(cat "$dotest/cmt.
$1")"
103 echo "$cmt" > "$dotest/current"
104 hd
=$
(git rev-parse
--verify HEAD
)
105 cmt_name
=$
(git symbolic-ref HEAD
2> /dev
/null ||
echo HEAD
)
106 msgnum
=$
(cat "$dotest/msgnum")
107 end
=$
(cat "$dotest/end")
108 eval GITHEAD_
$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
109 eval GITHEAD_
$hd='$(cat "$dotest/onto_name")'
110 export GITHEAD_
$cmt GITHEAD_
$hd
111 if test -n "$GIT_QUIET"
113 export GIT_MERGE_VERBOSITY
=1
115 git-merge-
$strategy "$cmt^" -- "$hd" "$cmt"
119 unset GITHEAD_
$cmt GITHEAD_
$hd
123 git rerere
$allow_rerere_autoupdate
127 echo "Strategy: $rv $strategy failed, try another" 1>&2
131 die
"Unknown exit code ($rv) from command:" \
132 "git-merge-$strategy $cmt^ -- HEAD $cmt"
137 move_to_original_branch
() {
138 test -z "$head_name" &&
139 head_name
="$(cat "$dotest"/head-name)" &&
140 onto
="$(cat "$dotest"/onto)" &&
141 orig_head
="$(cat "$dotest"/orig-head)"
144 message
="rebase finished: $head_name onto $onto"
145 git update-ref
-m "$message" \
146 $head_name $
(git rev-parse HEAD
) $orig_head &&
147 git symbolic-ref HEAD
$head_name ||
148 die
"Could not move back to $head_name"
154 move_to_original_branch
155 git notes copy
--for-rewrite=rebase
< "$dotest"/rewritten
156 if test -x "$GIT_DIR"/hooks
/post-rewrite
&&
157 test -s "$dotest"/rewritten
; then
158 "$GIT_DIR"/hooks
/post-rewrite rebase
< "$dotest"/rewritten
169 interactive_rebase
=explicit
172 -p|
--preserve-merges)
173 interactive_rebase
=implied
179 if [ "$interactive_rebase" = implied
]; then
184 test -n "$interactive_rebase" ||
test -f "$dotest"/interactive
187 run_pre_rebase_hook
() {
188 if test -z "$OK_TO_SKIP_PRE_REBASE" &&
189 test -x "$GIT_DIR/hooks/pre-rebase"
191 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
192 die
"The pre-rebase hook refused to rebase."
196 test -f "$GIT_DIR"/rebase-apply
/applying
&&
197 die
'It looks like git-am is in progress. Cannot rebase.'
199 is_interactive
"$@" && exec git-rebase--interactive
"$@"
205 OK_TO_SKIP_PRE_REBASE
=yes
208 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
209 die
"No rebase in progress?"
211 git update-index
--ignore-submodules --refresh &&
212 git diff-files
--quiet --ignore-submodules ||
{
213 echo "You must edit all merge conflicts and then"
214 echo "mark them as resolved using git add"
219 prev_head
=$
(cat "$dotest/prev_head")
220 end
=$
(cat "$dotest/end")
221 msgnum
=$
(cat "$dotest/msgnum")
222 onto
=$
(cat "$dotest/onto")
223 GIT_QUIET
=$
(cat "$dotest/quiet")
225 while test "$msgnum" -le "$end"
233 head_name
=$
(cat "$GIT_DIR"/rebase-apply
/head-name
) &&
234 onto
=$
(cat "$GIT_DIR"/rebase-apply
/onto
) &&
235 orig_head
=$
(cat "$GIT_DIR"/rebase-apply
/orig-head
) &&
236 GIT_QUIET
=$
(cat "$GIT_DIR"/rebase-apply
/quiet
)
237 git am
--resolved --3way --resolvemsg="$RESOLVEMSG" &&
238 move_to_original_branch
242 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
243 die
"No rebase in progress?"
245 git
reset --hard HEAD ||
exit $?
249 prev_head
=$
(cat "$dotest/prev_head")
250 end
=$
(cat "$dotest/end")
251 msgnum
=$
(cat "$dotest/msgnum")
252 msgnum
=$
(($msgnum + 1))
253 onto
=$
(cat "$dotest/onto")
254 GIT_QUIET
=$
(cat "$dotest/quiet")
255 while test "$msgnum" -le "$end"
263 head_name
=$
(cat "$GIT_DIR"/rebase-apply
/head-name
) &&
264 onto
=$
(cat "$GIT_DIR"/rebase-apply
/onto
) &&
265 orig_head
=$
(cat "$GIT_DIR"/rebase-apply
/orig-head
) &&
266 GIT_QUIET
=$
(cat "$GIT_DIR"/rebase-apply
/quiet
)
267 git am
-3 --skip --resolvemsg="$RESOLVEMSG" &&
268 move_to_original_branch
272 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
273 die
"No rebase in progress?"
278 GIT_QUIET
=$
(cat "$dotest/quiet")
279 move_to_original_branch
281 dotest
="$GIT_DIR"/rebase-apply
282 GIT_QUIET
=$
(cat "$dotest/quiet")
283 move_to_original_branch
285 git
reset --hard $
(cat "$dotest/orig-head")
290 test 2 -le "$#" || usage
294 -M|
-m|
--m|
--me|
--mer|
--merg|
--merge)
297 -s=*|
--s=*|
--st=*|
--str=*|
--stra=*|
--strat=*|
--strate=*|\
298 --strateg=*|
--strategy=*|\
299 -s|
--s|
--st|
--str|
--stra|
--strat|
--strate|
--strateg|
--strategy)
302 strategy
=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
324 git_am_opt
="$git_am_opt -q"
329 git_am_opt
="$git_am_opt $1"
331 --whitespace=fix|
--whitespace=strip
)
337 git_am_opt
="$git_am_opt $1"
339 --committer-date-is-author-date|
--ignore-date)
340 git_am_opt
="$git_am_opt $1"
344 git_am_opt
="$git_am_opt $1"
349 -f|
--f|
--fo|
--for|
--forc|
--force|
--force-r|
--force-re|
--force-reb|
--force-reba|
--force-rebas|
--force-rebase|
--no-ff)
352 --rerere-autoupdate|
--no-rerere-autoupdate)
353 allow_rerere_autoupdate
="$1"
364 test $# -gt 2 && usage
366 if test $# -eq 0 && test -z "$rebase_root"
368 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
369 test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply
/rebasing
&&
370 die
'A rebase is in progress, try --continue, --skip or --abort.'
373 # Make sure we do not have $GIT_DIR/rebase-apply
374 if test -z "$do_merge"
376 if mkdir
"$GIT_DIR"/rebase-apply
2>/dev
/null
378 rmdir "$GIT_DIR"/rebase-apply
381 It seems that I cannot create a rebase-apply directory, and
382 I wonder if you are in the middle of patch application or another
383 rebase. If that is not the case, please
384 rm -fr '"$GIT_DIR"'/rebase-apply
385 and run me again. I am stopping in case you still have something
392 die
"previous rebase directory $dotest still exists." \
393 'Try git rebase (--continue | --abort | --skip)'
397 # The tree must be really really clean.
398 if ! git update-index
--ignore-submodules --refresh > /dev
/null
; then
399 echo >&2 "cannot rebase: you have unstaged changes"
400 git diff-files
--name-status -r --ignore-submodules -- >&2
403 diff=$
(git diff-index
--cached --name-status -r --ignore-submodules HEAD
--)
405 ?
*) echo >&2 "cannot rebase: your index contains uncommitted changes"
411 if test -z "$rebase_root"
413 # The upstream head must be given. Make sure it is valid.
416 upstream
=`git rev-parse --verify "${upstream_name}^0"` ||
417 die
"invalid upstream $upstream_name"
419 upstream_arg
="$upstream_name"
421 test -z "$newbase" && die
"--root must be used with --onto"
425 upstream_arg
="$root_flag"
428 # Make sure the branch to rebase onto is valid.
429 onto_name
=${newbase-"$upstream_name"}
432 if left
=${onto_name%...*} right
=${onto_name#*...} &&
433 onto
=$
(git merge-base
--all ${left:-HEAD} ${right:-HEAD})
437 die
"$onto_name: there are more than one merge bases"
440 die
"$onto_name: there is no merge base"
444 die
"$onto_name: there is no merge base"
448 onto
=$
(git rev-parse
--verify "${onto_name}^0") ||
exit
452 # If a hook exists, give it a chance to interrupt
453 run_pre_rebase_hook
"$upstream_arg" "$@"
455 # If the branch to rebase is given, that is the branch we will rebase
456 # $branch_name -- branch being rebased, or HEAD (already detached)
457 # $orig_head -- commit object name of tip of the branch before rebasing
458 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
462 # Is it "rebase other $branchname" or "rebase other $commit"?
466 if git show-ref
--verify --quiet -- "refs/heads/$1" &&
467 branch
=$
(git rev-parse
-q --verify "refs/heads/$1")
469 head_name
="refs/heads/$1"
470 elif branch
=$
(git rev-parse
-q --verify "$1")
472 head_name
="detached HEAD"
478 # Do not need to switch branches, we are already on it.
479 if branch_name
=`git symbolic-ref -q HEAD`
481 head_name
=$branch_name
482 branch_name
=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
484 head_name
="detached HEAD"
485 branch_name
=HEAD
;# detached
487 branch
=$
(git rev-parse
--verify "${branch_name}^0") ||
exit
492 # Now we are rebasing commits $upstream..$branch (or with --root,
493 # everything leading up to $branch) on top of $onto
495 # Check if we are already based on $onto with linear history,
496 # but this should be done only when upstream and onto are the same.
497 mb
=$
(git merge-base
"$onto" "$branch")
498 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
500 ! (git rev-list
--parents "$onto"..
"$branch" | sane_grep
" .* ") > /dev
/null
502 if test -z "$force_rebase"
504 # Lazily switch to the target branch if needed...
505 test -z "$switch_to" || git checkout
"$switch_to"
506 say
"Current branch $branch_name is up to date."
509 say
"Current branch $branch_name is up to date, rebase forced."
513 # Detach HEAD and reset the tree
514 say
"First, rewinding head to replay your work on top of it..."
515 git checkout
-q "$onto^0" || die
"could not detach HEAD"
516 git update-ref ORIG_HEAD
$branch
518 if test -n "$diffstat"
520 if test -n "$verbose"
522 echo "Changes from $mb to $onto:"
524 # We want color (if set), but no pager
525 GIT_PAGER
='' git
diff --stat --summary "$mb" "$onto"
528 # If the $onto is a proper descendant of the tip of the branch, then
529 # we just fast-forwarded.
530 if test "$mb" = "$branch"
532 say
"Fast-forwarded $branch_name to $onto_name."
533 move_to_original_branch
537 if test -n "$rebase_root"
539 revisions
="$onto..$orig_head"
541 revisions
="$upstream..$orig_head"
544 if test -z "$do_merge"
546 git format-patch
-k --stdout --full-index --ignore-if-in-upstream \
547 --no-renames $root_flag "$revisions" |
548 git am
$git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
549 move_to_original_branch
551 test 0 != $ret -a -d "$GIT_DIR"/rebase-apply
&&
552 echo $head_name > "$GIT_DIR"/rebase-apply
/head-name
&&
553 echo $onto > "$GIT_DIR"/rebase-apply
/onto
&&
554 echo $orig_head > "$GIT_DIR"/rebase-apply
/orig-head
&&
555 echo "$GIT_QUIET" > "$GIT_DIR"/rebase-apply
/quiet
559 # start doing a rebase with git-merge
560 # this is rename-aware if the recursive (default) strategy is used
563 echo "$onto" > "$dotest/onto"
564 echo "$onto_name" > "$dotest/onto_name"
566 echo "$prev_head" > "$dotest/prev_head"
567 echo "$orig_head" > "$dotest/orig-head"
568 echo "$head_name" > "$dotest/head-name"
569 echo "$GIT_QUIET" > "$dotest/quiet"
572 for cmt
in `git rev-list --reverse --no-merges "$revisions"`
574 msgnum
=$
(($msgnum + 1))
575 echo "$cmt" > "$dotest/cmt.$msgnum"
578 echo 1 >"$dotest/msgnum"
579 echo $msgnum >"$dotest/end"
584 while test "$msgnum" -le "$end"